﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LiraAPI;
using FEModel;
using System.Windows.Forms;

namespace Arm
{
    public class Class1 : ILiraAPI
    {
        ReturnCodes ILiraAPI.ExecuteProgram_Result(IResultLiraAPI pResultLiraAPI, int NodesNumber, int ElementsNumber, List<List<Results_Key>> pAllCases, Results_Key pCurentCase)
        {
            List<int> elementArray = new List<int>(); // номера элементов
            for (int i = 0; i < ElementsNumber; i++)
            {
                elementArray.Add(i);
            }
            FEModel.e_Results_ColumnType[] e_Results_ColumnTypes = null;
            string[] pNameColumns = null;
            System.Data.DataTable allEments = pResultLiraAPI.get_TableResult(e_Results_TableType.RTT_ELEMENTS, elementArray, new List<Results_Key> { pCurentCase }, ref e_Results_ColumnTypes, ref pNameColumns);
            List<int> selectedElement = new List<int>();
            for (int i = 0; i < allEments.Rows.Count; i++)
            {
                if ((bool)allEments.Rows[i]["RCT_IS_SELECT"])
                {
                    selectedElement.Add(Convert.ToInt32(allEments.Rows[i]["RCT_NUMBER"]) - 1);
                }
            }
            System.Data.DataTable armTable = pResultLiraAPI.get_TableResult(e_Results_TableType.RTT_PLATE_REINFORCED_CONCRETE_RSU, selectedElement, new List<Results_Key> { pCurentCase }, ref e_Results_ColumnTypes, ref pNameColumns);
            double sumAs1X = 0;
            double sumAs2X = 0;
            double sumAs3Y = 0;
            double sumAs4Y = 0;
            foreach (var item in selectedElement)
            {
                var row = armTable.Select("[1RCT_NUMBER]="+(item+1).ToString());
                double Area = Convert.ToDouble(allEments.Rows[item]["RCT_PLATE_AREA"]);
                double As1X = Convert.ToDouble(row[0][Array.IndexOf(pNameColumns, "As1X")]) * Area;
                double As2X = Convert.ToDouble(row[0][Array.IndexOf(pNameColumns, "As2X")]) * Area;
                double As3Y = Convert.ToDouble(row[0][Array.IndexOf(pNameColumns, "As3Y")]) * Area;
                double As4Y = Convert.ToDouble(row[0][Array.IndexOf(pNameColumns, "As4Y")]) * Area;
                sumAs1X = sumAs1X + As1X;
                sumAs2X = sumAs2X + As2X;
                sumAs3Y = sumAs3Y + As3Y;
                sumAs4Y = sumAs4Y + As4Y;
            }
            
            double sumWeigth = Math.Round((sumAs1X+ sumAs2X+ sumAs3Y+ sumAs4Y)*7850,3);
            MessageBox.Show("Расчетная масса арматуры: " + Convert.ToString(sumWeigth) + "кг");
            return ReturnCodes.RC_OK;
        }
    }
}
